Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.digester3
Class SetPropertiesRule

    java.lang.Object
      org.apache.commons.digester3.Rule
          org.apache.commons.digester3.SetPropertiesRule

    public class SetPropertiesRule

extends Rule

Rule implementation that sets properties on the object at the top of the stack, based on attributes with corresponding names.

This rule supports custom mapping of attribute names to property names. The default mapping for particular attributes can be overridden by using `SetPropertiesRule(String[] attributeNames, String[] propertyNames)`. This allows attributes to be mapped to properties with different names. Certain attributes can also be marked to be ignored.

Constructor Summary
`SetPropertiesRule()` Base constructor.
`SetPropertiesRule(Map<String,String> aliases)` Constructor allows attribute->property mapping to be overriden.
`SetPropertiesRule(String[] attributeNames, String[] propertyNames)` Constructor allows attribute->property mapping to be overriden.
`SetPropertiesRule(String attributeName, String propertyName)` Convenience constructor overrides the mapping for just one property.

Method Summary
`void` | `addAlias(String attributeName, String propertyName)` Add an additional attribute name to property name mapping.
`void` | `begin(String namespace, String name, Attributes attributes)` This method is called when the beginning of a matching XML element is encountered.
`boolean` | `isIgnoreMissingProperty()` Are attributes found in the xml without matching properties to be ignored?
`void` | `setIgnoreMissingProperty(boolean ignoreMissingProperty)` Sets whether attributes found in the xml without matching properties should be ignored.
`String` | `toString()`

Methods inherited from class org.apache.commons.digester3.Rule
`body, end, finish, getDigester, getNamespaceURI, setDigester, setNamespaceURI`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SetPropertiesRule

    public SetPropertiesRule()

  Base constructor.

### SetPropertiesRule

    public SetPropertiesRule(String attributeName,
                             String propertyName)

  Convenience constructor overrides the mapping for just one property.

  For details about how this works, see `SetPropertiesRule(String[] attributeNames, String[] propertyNames)` .

  Parameters:
    `attributeName` - map this attribute
    `propertyName` - to a property with this name

### SetPropertiesRule

    public SetPropertiesRule(String[] attributeNames,
                             String[] propertyNames)

  Constructor allows attribute->property mapping to be overriden.

  Two arrays are passed in. One contains the attribute names and the other the property names. The attribute name / property name pairs are match by position In order words, the first string in the attribute name list matches to the first string in the property name list and so on.

  If a property name is null or the attribute name has no matching property name, then this indicates that the attibute should be ignored.

  ##### Example One

  The following constructs a rule that maps the `alt-city` attribute to the `city` property and the `alt-state` to the `state` property. All other attributes are mapped as usual using exact name matching. ``

            SetPropertiesRule(
                      new String[] {"alt-city", "alt-state"},
                      new String[] {"city", "state"});

  ##### Example Two

  The following constructs a rule that maps the `class` attribute to the `className` property. The attribute `ignore-me` is not mapped. All other attributes are mapped as usual using exact name matching. ``

            SetPropertiesRule(
                      new String[] {"class", "ignore-me"},
                      new String[] {"className"});

  Parameters:
    `attributeNames` - names of attributes to map
    `propertyNames` - names of properties mapped to

### SetPropertiesRule

    public SetPropertiesRule(Map<String,String> aliases)

  Constructor allows attribute->property mapping to be overriden.

  Parameters:
    `aliases` - attribute->property mapping
  Since:
    3.0

Method Detail

### begin

    public void begin(String namespace,
                      String name,
                      Attributes attributes)
               throws Exception

  This method is called when the beginning of a matching XML element is encountered.

  Overrides:
    `begin` in class `Rule`
  Parameters:
    `namespace` - the namespace URI of the matching element, or an empty string if the parser is not namespace aware or the element has no namespace
    `name` - the local name if the parser is namespace aware, or just the element name otherwise
    `attributes` - The attribute list of this element
  Throws:
    `Exception` - if any error occurs

### addAlias

    public void addAlias(String attributeName,
                         String propertyName)

  Add an additional attribute name to property name mapping. This is intended to be used from the xml rules.

  Parameters:
    `attributeName` - the attribute name has to be mapped
    `propertyName` - the target property name

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### isIgnoreMissingProperty

    public boolean isIgnoreMissingProperty()

  Are attributes found in the xml without matching properties to be ignored?

  If false, the parsing will interrupt with an `NoSuchMethodException` if a property specified in the XML is not found. The default is true.

  Returns:
    true if skipping the unmatched attributes.

### setIgnoreMissingProperty

    public void setIgnoreMissingProperty(boolean ignoreMissingProperty)

  Sets whether attributes found in the xml without matching properties should be ignored. If set to false, the parsing will throw an `NoSuchMethodException` if an unmatched attribute is found. This allows to trap misspellings in the XML file.

  Parameters:
    `ignoreMissingProperty` - false to stop the parsing on unmatched attributes.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2011 The Apache Software Foundation. All Rights Reserved.